ClickStack: Create Role
This endpoint is in beta. API contract is stable, and no breaking changes are expected in the future.
ClickStack: Creates a new custom role for the team.
POST
/
v1
/
organizations
/
{organizationId}
/
services
/
{serviceId}
/
clickstack
/
roles
ClickStack: Create Role
curl --request POST \
--url https://api.clickhouse.cloud/v1/organizations/{organizationId}/services/{serviceId}/clickstack/roles \
--header 'Authorization: Basic <encoded-value>' \
--header 'Content-Type: application/json' \
--data '
{
"name": "Deploy Bot",
"permissions": [
{
"action": "read",
"subject": "dashboard",
"inverted": false,
"integration": "mongodb",
"conditions": {}
}
],
"description": "Manages dashboards via Terraform"
}
'import requests
url = "https://api.clickhouse.cloud/v1/organizations/{organizationId}/services/{serviceId}/clickstack/roles"
payload = {
"name": "Deploy Bot",
"permissions": [
{
"action": "read",
"subject": "dashboard",
"inverted": False,
"integration": "mongodb",
"conditions": {}
}
],
"description": "Manages dashboards via Terraform"
}
headers = {
"Authorization": "Basic <encoded-value>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Basic <encoded-value>', 'Content-Type': 'application/json'},
body: JSON.stringify({
name: 'Deploy Bot',
permissions: [
{
action: 'read',
subject: 'dashboard',
inverted: false,
integration: 'mongodb',
conditions: {}
}
],
description: 'Manages dashboards via Terraform'
})
};
fetch('https://api.clickhouse.cloud/v1/organizations/{organizationId}/services/{serviceId}/clickstack/roles', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"status": 200,
"requestId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"result": {
"id": "507f1f77bcf86cd799439011",
"name": "Read Only",
"permissions": [
{
"action": "read",
"subject": "dashboard",
"inverted": false,
"integration": "mongodb",
"conditions": {}
}
],
"isPredefined": false,
"description": "Read-only access to all resources",
"createdAt": "2025-01-01T00:00:00.000Z",
"updatedAt": "2025-06-15T10:30:00.000Z"
}
}{
"status": 400,
"error": "<string>",
"requestId": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}{
"status": 500,
"error": "<string>",
"requestId": "3c90c3cc-0d44-4b50-8888-8dd25736052a"
}Beta
This endpoint is in beta. API contract is stable, and no breaking changes are expected in the future.
ClickStack: Creates a new custom role for the team.
ClickStack: Creates a new custom role for the team.
Authorizations
Use key ID and key secret obtained in ClickHouse Cloud console: https://clickhouse.com/docs/cloud/manage/openapi
Path Parameters
ID of the organization that owns the service.
ID of the ClickStack service.
Body
application/json
Role name. Must be unique within the team and not collide with a predefined role.
Example:
"Deploy Bot"
The CASL permissions to grant to the role.
Show child attributes
Show child attributes
Human-readable role description.
Example:
"Manages dashboards via Terraform"
Last modified on July 22, 2026
Was this page helpful?
Previous
ClickStack: Get Role**This endpoint is in beta.** API contract is stable, and no breaking changes are expected in the future. <br /><br /> ClickStack: Retrieves a specific role by ID.
Next
⌘I
ClickStack: Create Role
